Public Class Test_RS232

    Private Delegate Sub _Affiche_ASCII(ByVal donnee As String)
    Private Delegate Sub _affiche_Hexa(ByVal donnee As String)

    Private Sub Test_RS232_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim ports() As String = IO.Ports.SerialPort.GetPortNames() ' tableau de string acceuillant les ports present sur la machine

        'configuration du port RS232
        RS232.BaudRate = 9600 'vitesse du port
        RS232.Parity = IO.Ports.Parity.None 'pas de parit
        RS232.StopBits = IO.Ports.StopBits.One 'un bit d'arrt par octet
        RS232.DataBits = 8 'nombre de bit par octet
        RS232.RtsEnable = False 'ligne Rts dsactiv
        RS232.DtrEnable = False 'ligne Dtr dsactiv


        Choix_Port.Items.AddRange(ports) ' on ajoute le nom des ports dans le combobox

        Try

            Choix_Port.SelectedIndex = 0 ' on donne le focus au premier port du combobox

        Catch ' message d'erreur si aucun port COM n'est dtect sur la machine et on ferme l'application

            MsgBox("Il semble ne pas y avoir de port RS232 sur votre machine, cette application ne pourra pas marcher")
            Application.Exit()

        End Try
    End Sub


    Private Sub Connexion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Connexion.Click

        If Connexion.Text = "Connexion" Then

            Try

                'on ouvre le port dsir
                RS232.PortName = Choix_Port.Text
                RS232.Open()

            Catch ' message d'erreur si l'on ne peut pas ouvrir le port

                MsgBox("Il semble que le port choisi est dj en cours d'utilisation par une autre application, merci de choisir un port libre pour se connecter")
                Exit Sub

            End Try

            Vitesse.Text = RS232.BaudRate & Space(1) & "Bauds" 'on affiche la vitesse du port
            Connexion.Text = "Dconnexion" ' on change l'intitul du bouton
            Choix_Port.Enabled = False ' on dsactive le combobox pendant l'utilisation du port
        Else

            Vitesse.Text = "" 'on efface la vitesse
            Connexion.Text = "Connexion" ' on change l'intitul du bouton
            RS232.Close() 'on ferme le port
            Choix_Port.Enabled = True 'on ractive le combobox

        End If
    End Sub

    'Evnement se dclenchant lors de l'arrive de donnes sur le port RS232
    Private Sub RS232_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles RS232.DataReceived
        Dim nb_octet As Integer = RS232.BytesToRead ' on rcupre le nombre d'octet prsent dans le tampon
        Dim trame(nb_octet - 1) As Byte ' Tableau acceuillant les donnes au format byte

        RS232.Read(trame, 0, nb_octet) 'on lit le port

        Dim donnee As String = System.Text.Encoding.ASCII.GetString(trame) ' on rcupre les donnes au format ASCII

        'L'vnement DataReceived se situe sur un thread diffrent que le form, nous devons donc appel un dlgu pour afficher le rsultat  l'cran
        If Me.InvokeRequired Then
            Me.Invoke(New _Affiche_ASCII(AddressOf Affiche_ASCII), donnee)
        End If

        'On va convertir tous les octets du tableau en valeurs Hexadecimal pour les afficher  l'cran
        Array.ForEach(Of Byte)(trame, AddressOf Trt_Trame)
    End Sub

    Private Sub Trt_Trame(ByVal bit As Byte)
        'on appelle le dlgu pour afficher les donnes
        If Me.InvokeRequired Then
            Me.Invoke(New _affiche_Hexa(AddressOf Affiche_Hexa), Hex(bit).PadLeft(2, "0") & "H" & Space(1)) ' on convertit l'octet en valeur Hexadcimal en faisant attention qu'il reste cod sur 2 caractres et on ajoute un espace pour faciliter la lecture
        End If
    End Sub

    Private Sub Affiche_ASCII(ByVal donnee As String)
        RTB_ASCII.AppendText(donnee) 'On affiche les donnes  l'cran
    End Sub

    Private Sub Affiche_Hexa(ByVal donnee As String)
        RTB_Hexa.AppendText(donnee) 'on affiche les donnes  l'cran
    End Sub
End Class
